import { select, range, scaleOrdinal } from 'd3';
 
const svg = select('svg');

const width  = parseFloat(svg.attr('width'));
const height = parseFloat(svg.attr('height'));

const colorScale = scaleOrdinal()
	.domain(['apple', 'lemon'])
	.range(['darkred', 'yellow']);

const radiusScale = scaleOrdinal()
	.domain(['apple', 'lemon'])
	.range([40, 25]);

const render = (selection, { fruits }) => {
  const circles = selection.selectAll('circle')
  		.data(fruits);
  
  circles
    .enter().append('circle')
      .attr('cx', (d, i) => i * 100 + 60)
      .attr('cy', height / 2)
      .attr('fill', d => colorScale(d.type))
  		.attr('r', d => radiusScale(d.type))
    .on('mouseover', function (d, i) {
            select(this).transition()
                 .duration('200')
                 .attr('r', '70')
                 .attr('stroke', 'black')
                 .attr('stroke-width', 5)})
    .on('mouseout', function (d, i) {
            select(this).transition()
                 .duration('200')
                 .attr('r', '40')
                 .attr('stroke', null)});
  circles
    	.attr('fill', d => colorScale(d.type))
  		.attr('r', d => radiusScale(d.type))
  		.attr('stroke', 'black')
  		.on('mouseover', function (d, i) {
            select(this).transition()
                 .duration('200')
                 .attr('r', '70')
                 .attr('stroke', 'black')
                 .attr('stroke-width', 5)})
    .on('mouseout', function (d, i) {
            select(this).transition()
                 .duration('200')
                 .attr('r', d => radiusScale(d.type))
                 .attr('stroke', null)});
  circles
		.exit().remove();
}

const makeFruit = type => ({type});

const fruits = range(5)
	.map(() => [makeFruit('apple')]);

render(svg, { fruits })


// Eat an apple
setTimeout(() => {
  fruits.pop();
  render(svg, { fruits });
}, 2000);

// Replace with a lemon
setTimeout(() => {
  fruits[2].type = 'lemon';
  render(svg, { fruits });
}, 2000);

